function load_objects()
  -- object "enums"
  VECTOR2        = 1
  STATE          = 2
  STATE_MANAGER  = 3
  TIMER          = 4
  MASTER_TIMER   = 5
  KEY            = 6
  BUTTON         = 7 
  KEYBOARD       = 8
  EVENT          = 9
  EVENT_MANAGER  = 10
  BBOX           = 11
  BTRI           = 12
  MOUSE_INPUT    = 13
  MENU_ENTRY     = 14
  MENU           = 15
  SOUND_EFFECT   = 16
  COLOR_PALETTE  = 17
  TILE           = 18
  TILE_MAP       = 19
  TILE_TYPE      = 20   -- tile type enums in tile_types.lua
  TILE_CHUNK     = 21
  CAMERA2D       = 22
  PHYS_POINT     = 23
  PHYS_STEER     = 24
  HERO					 = 25
  MAP_POINT      = 26
  COLLIDER       = 27
  GUN            = 28
  BULLET         = 29
  FLOCK          = 30
  BOID           = 31
  MAP_BODY       = 32
  
  -- object tables
  vector2 = require('objects/vector2')
  state = require('objects/state')
  state_manager = require('objects/state_manager')
  
  timers = require('objects/timers')
  timer, master_timer = timers[1], timers[2]
  
  local keyboard_objects = require('objects/keyboard')
  key, button, keyboard = keyboard_objects[1], keyboard_objects[2], keyboard_objects[3]
  
  events = require('objects/events')
  event, event_manager = events[1], events[2]
  
  bbox = require('objects/bbox')  -- bounding box
  btri = require('objects/btri')  -- bounding triangle
  
  mouse_input = require('objects/mouse_input')
  
  local menu_objects = require('objects/menu')
  menu_entry, menu = menu_objects[1], menu_objects[2]
  
  sound_effect = require('objects/sound_effect')
  
  color_palette = require('objects/color_palette')
  
  tile = require('objects/tile')
  tile_map = require('objects/tile_map')
  
  tile_types = require('objects/tile_types')
  t_walk = tile_types[T_WALK]
  t_wall = tile_types[T_WALL]
  
  tile_chunk = require("objects/tile_chunk")
  
  camera2d = require("objects/camera2d")
  
  physics = require("objects/physics")
  
  cubic_spline = require('objects/cubic_spline')
  
  hero = require('objects/hero')
  
  map_point = require('objects/map_point')
  map_body = require('objects/map_body')
  
  collider = require('objects/collider')
  
  gun = require('objects/gun')
  bullet = require('objects/bullet')
  
  flock = require('objects/flock')
  boid = require('objects/boid')
  
  
end













