-- direction enums
UP        = 1
UPRIGHT   = 2
RIGHT     = 3
DOWNRIGHT = 4
DOWN      = 5
DOWNLEFT  = 6
LEFT      = 7
UPLEFT    = 8

-- normals
local diag = 1/math.sqrt(2)
NORMAL = {}
NORMAL[UP]        = vector2:new(0, -1)
NORMAL[UPRIGHT]   = vector2:new(diag, -diag)
NORMAL[RIGHT]     = vector2:new(1, 0)
NORMAL[DOWNRIGHT] = vector2:new(diag, diag)
NORMAL[DOWN]      = vector2:new(0, 1)
NORMAL[DOWNLEFT]  = vector2:new(-diag, diag)
NORMAL[LEFT]      = vector2:new(-1, 0)
NORMAL[UPLEFT]    = vector2:new(-diag, -diag)

--##########################################################################--
--[[----------------------------------------------------------------------]]--
-- tile object
--[[----------------------------------------------------------------------]]--
--##########################################################################--
local tile = {}
tile.table = TILE
tile.parent = nil    -- tile is child of a tile_map
tile.chunk = nil     -- chunk that the tile belongs to
tile.x = nil         -- world coordinate
tile.y = nil
tile.batch_x = nil   -- chunk sprite batch coordinate
tile.batch_y = nil
tile.type = nil
tile.neighbours = nil

local tile_mt = { __index = tile }
function tile:new()
  return setmetatable({}, tile_mt)
end

------------------------------------------------------------------------------
function tile:set_type(tile_type)
  tile_type.parent = self
  self.type = tile_type
end

------------------------------------------------------------------------------
-- tiles = {up, upright, right, downright, down, downleft, left, upright}
function tile:set_neighbours(tiles)
  self.neighbours = tiles
end

------------------------------------------------------------------------------
function tile:set_parent(parent) self.parent = parent end
function tile:set_chunk(chunk) self.chunk = chunk end

------------------------------------------------------------------------------
function tile:update(dt)
end

------------------------------------------------------------------------------
function tile:draw()
end

return tile











