-- tile type 'enums'
T_WALK = 1
T_WALL = 2
T_BREAK = 3

--##########################################################################--
--[[----------------------------------------------------------------------]]--
-- t_template
--[[----------------------------------------------------------------------]]--
--##########################################################################--

local t_template = {}
t_template.table = 't_template'
t_template.parent = nil
t_template.quad = nil
t_template.walkable = false

local t_template_mt = { __index = t_template }
function t_template:new()
  return setmetatable({}, t_template_mt)
end

-----------------------------------------------------------------------------
function t_template:set_quad(quad)
  self.quad = quad
end

-----------------------------------------------------------------------------
function t_template:update(dt)
end

--return t_template

--##########################################################################--
--[[----------------------------------------------------------------------]]--
-- t_walk  (walkable tile) 
--[[----------------------------------------------------------------------]]--
--##########################################################################--
local t_walk = {}
t_walk.table = T_WALK
t_walk.parent = nil
t_walk.quad = nil
t_walk.walkable = true

local t_walk_mt = { __index = t_walk }
function t_walk:new()
  return setmetatable({}, t_walk_mt)
end

-----------------------------------------------------------------------------
function t_walk:set_quad(quad)
  self.quad = quad
end

-----------------------------------------------------------------------------
function t_walk:update(dt)
end



--##########################################################################--
--[[----------------------------------------------------------------------]]--
-- t_wall  (non walkable tile) 
--[[----------------------------------------------------------------------]]--
--##########################################################################--
local t_wall = {}
t_wall.table = T_WALL
t_wall.parent = nil
t_wall.quad = nil
t_wall.walkable = false

local t_wall_mt = { __index = t_wall }
function t_wall:new()
  return setmetatable({}, t_wall_mt)
end

-----------------------------------------------------------------------------
function t_wall:set_quad(quad)
  self.quad = quad
end

-----------------------------------------------------------------------------
function t_wall:update(dt)
end



return {t_walk, t_wall}











