local first_state = state:new()
first_state.label = 'string'
first_state.keyboard_layout = 'first_state'

--##########################################################################--
--[[----------------------------------------------------------------------]]--
--      LOAD
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function first_state.load(resolutions)
  lg.setBackgroundColor(255, 255, 255 ,255)
  events = event_manager:new()

  -- color palette test
  local r, g, b = math.random(0,255), math.random(0,255), math.random(0,255)
  colors = color_palette:new(64, 64, 10, {r, g, b})
  h = colors.ref_color[1]
  
  colors:get_image()
  
  -- menu/sound test
  menu = menu:new(100, 200, 300, 400, courier_small)
  menu:add_entry('hello', function() 
                            h = h + 30
                            colors:add_color(h)
                            colors:get_image()
                          end)
                          
  menu:add_entry('FULLSCREEN', function()
																 local func = function()
																 	 FULLSCREEN = true
																 	 RANDCOLOUR = true
																 	 local width = resolutions[1][1]
																 	 local height = resolutions[1][2]
																	 lg.resize_window(width, height)
																	 invaders:load_next_state(str)
																 end
																 
																 event:new(events, {func, 100}, 500)
																 --menu.hover_sound:disable()
																 controls:disable_all()
															end)
                          
  for _,v in ipairs(resolutions) do
    local width, height = v[1], v[2]
    local str = width..' x '..height
    
    local action = function()
                     local func = function()
                       lg.resize_window(width, height)
                       invaders:load_next_state(str)
                     end
                     
                     event:new(events, {func, 100}, 500)
                     --menu.hover_sound:disable()
                     controls:disable_all()
                   end
                   
    menu:add_entry(str, action)
  end
  
  menu:add_entry('EXIT', function()
																 local func = function()
																 	 love.event.push('quit')
																 end
																 
																 event:new(events, {func, 100}, 0)
																 --menu.hover_sound:disable()
																 controls:disable_all()
															end)
  
  -- just skip to the next state right now
  local action = function()
                     local func = function()
                       lg.resize_window(SCR_WIDTH, SCR_HEIGHT)
                       invaders:load_nexts_state(str)
                     end
                     
                     event:new(events, {func, 0}, 0)
                     menu.hover_sound:disable()
                     controls:disable_all()
                   end
                   
  lg.resize_window(SCR_WIDTH, SCR_HEIGHT)
  --invaders:load_next_state(str)
  
  msg = "controls:\n\n- Click and drag mouse to MOVE\n"..
        "- hold left shift to SHOOT\n- escape to EXIT\n"..
        "- r to RESET\n\n extras:\n\n"..
        "- hold 't' to display collision debug\n"..
        "- hold 'h' to display player debug\n- hold 'c' to display camera debug\n"..
        "- hold 'up' to spawn  more objects\n- hold 'down' to remove objects from screen\n"..
        "- hold 's' to slow down time\n"..
        "- game may work if a joystick is plugged in,\n  but it might not"
end


--##########################################################################--
--[[----------------------------------------------------------------------]]--
--      UPDATE
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function first_state.update(dt)
  events:update(dt)
  colors:update(dt)
  menu:update(dt)
end


--##########################################################################--
--[[----------------------------------------------------------------------]]--
--     DRAW
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function first_state.draw()
  colors:draw()
  menu:draw()
  
  lg.print("TILE MAP AND COLLISION DEMO", 300, 100)
  lg.print(msg, 450, 200)
end


return first_state
