local second_state = state:new()
second_state.label = 'string'
second_state.keyboard_layout = 'second_state'


--##########################################################################--
--[[----------------------------------------------------------------------]]--
--      LOAD
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function second_state.load( )
	-- set up camera
	camera = camera2d:new()
	target = vector2:new(1000, 1000)
  camera:set_target(target, true)

	-- colors for map
  color1 = {math.random(255), math.random(255), math.random(255)}
  color2 = {math.random(255), math.random(255), math.random(255)}
  
  local samples = {{7, 184, 226, 255}, {109, 73, 245, 255},
  								 {7, 184, 226, 255}, {109, 73, 245, 255},
									 {217, 142, 115}, {40, 138, 218},
									 {43, 241, 83}, {90, 191, 92},
									 {193, 251, 18}, {6, 217, 61},
									 {60, 254, 133}, {255, 25, 45},
									 {155, 215, 105}, {2, 207, 219},
									 {254, 196, 113}, {66, 219, 248},
									 {251, 254, 212}, {110, 252, 133},
									 {227, 166, 116}, {219, 33, 29},
									 {57, 120, 127}, {45, 159, 60},
									 {144, 242, 28}, {227, 123, 109},
									 {150, 238, 210},  {247, 119, 106},
									 {17, 57, 232}, {76, 243, 93},
									 {2, 112, 132}, {232, 124, 125},
									 CL1_RED, CL1_TEAL,
									 CL1_RED_D, CL1_TEAL_D }
  
  local rand = 2 * math.random(1,math.floor(0.5 * #samples)) - 1
  color1 = samples[rand]
  color2 = samples[rand + 1]
  
  if not RANDCOLOUR then
  	color1 = CL1_RED
  	color2 = CL1_TEAL
  end
  
  num_colors = 80
  palette1 = color_palette:new(TILE_WIDTH, TILE_HEIGHT, num_colors, color1)
  palette2 = color_palette:new(TILE_WIDTH, TILE_HEIGHT, num_colors, color2)
  lg.setBackgroundColor(color2)
  
  print('color1: {'..color1[1]..', '..color1[2]..', '..color1[3]..'}')
  print('color2: {'..color2[1]..', '..color2[2]..', '..color2[3]..'}')
  
  -- set up map
  rows, cols = 100, 100
  map = tile_map:new(cols, rows)
  map:add_layer('images/100x100-back.png', T_WALL, palette1.palette[1])
  map:add_layer('images/100x100-wall.png', T_WALK, palette2.palette[1])
  --map:add_layer('images/50x50-test-back.png', T_WALL, palette1.palette[1])
  --map:add_layer('images/50x50-test-wall2.png', T_WALK, palette2.palette[1])
  map:set_camera(camera)
  
  map:load()
end


--##########################################################################--
--[[----------------------------------------------------------------------]]--
--      UPDATE
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function second_state.update(dt)
  
  map:update(dt)
  
  if map.is_loaded then 
  	invaders:load_next_state(map, camera)
  end
  
end
  

--##########################################################################--
--[[----------------------------------------------------------------------]]--
--     DRAW
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function second_state.draw()
  
  map:draw_load_progress()
  
end



return second_state










